<template>
  <div :class="className" :style="{height:height,width:width}" />
</template>

<script>
import echarts from 'echarts'
require('echarts/theme/macarons') // echarts theme
import resize from './mixins/resize'

const animationDuration = 6000

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '300px'
    },
    chartData: {
      type: Object,
      required: true
    }
  },
  watch: {
    chartData: {
      deep: true,
      handler(val) {
        this.setOptions(val)
      }
    }
  },
  data() {
    return {
      chart: null
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.initChart()
    })
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'macarons');
      this.chart = echarts.init(this.$el, 'macarons')
      this.setOptions(this.chartData)
    },
      setOptions({ y, x ,data } = {}) {
        console.log(y,x,data,56)
       this.chart.setOption({
         tooltip: {
           trigger: 'axis',
           axisPointer: { // 坐标轴指示器，坐标轴触发有效
             type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
           }
         },
         grid: {
           top: 10,
           left: '2%',
           right: '2%',
           bottom: '3%',
           containLabel: true
         },
         xAxis: [{
           type: 'category',
           data: y,
           axisTick: {
             alignWithLabel: true
           },
           axisLine: {   //  控制x轴线的样式
                              lineStyle: {
                                   type: 'solid',
                                  color: '#CECECE',
                                   width:'1' }
                                }
         }],
         yAxis: [{
           type: 'value',
           axisTick: {
             show: false
           },
            axisLine: {
                               lineStyle: {
                                    type: 'solid',
                                     color: '#CECECE',
                                   width:'1'
                               }
                              }
         }],
         series: [{
           name: '绿码',
           type: 'bar',
           stack: 'vistors',
           barWidth: '40%',
           itemStyle: {
           normal: {
           color: '#8ecd72',
           }
           },
           data: x[0].data,
           animationDuration
         }, {
           name: '灰码',
           type: 'bar',
           stack: 'vistors',
           barWidth: '40%',
           data: x[2].data,
           itemStyle: {
           normal: {
           color: '#536fcd',
           }
           },
           animationDuration
         }, {
           name: '未申领',
           type: 'bar',
           stack: 'vistors',
           barWidth: '40%',
           data: x[3].data,
           itemStyle: {
           normal: {
           color: '#f1c250',
           }
           },
           animationDuration
         },
         {
           name: '红码',
           type: 'bar',
           stack: 'vistors',
           barWidth: '40%',
           data: x[1].data,
           itemStyle: {
           normal: {
           color: '#e96a62',
           }
           },
           animationDuration
         }]
       })
      }
  }
}
</script>
